JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
PixelAlpha Class Reference
juce_graphics » colour

Represents an 8-bit single-channel pixel, and can perform compositing operations on it. More...

`#include <juce_PixelFormats.h>`

## Public Types
enum | { indexA = 0 }
| The indexes of the different components in the byte layout of this type of colour. More...

## Public Member Functions
| PixelAlpha () noexcept=default
| Creates a pixel without defining its colour.
forcedinline uint32 | getNativeARGB () const noexcept
| Returns a uint32 which represents the pixel in a platform dependent format which is compatible with the native format of a PixelARGB.
forcedinline uint32 | getInARGBMaskOrder () const noexcept
| Returns a uint32 which will be in argb order as if constructed with the following mask operation ((alpha << 24) | (red << 16) | (green << 8) | blue).
uint32 | getInARGBMemoryOrder () const noexcept
| Returns a uint32 which when written to memory, will be in the order a, r, g, b.
forcedinline uint32 | getEvenBytes () const noexcept
| Return channels with an even index and insert zero bytes between them.
forcedinline uint32 | getOddBytes () const noexcept
| Return channels with an odd index and insert zero bytes between them.
forcedinline uint8 | getAlpha () const noexcept
forcedinline uint8 | getRed () const noexcept
forcedinline uint8 | getGreen () const noexcept
forcedinline uint8 | getBlue () const noexcept
template<class Pixel >
forcedinline void | set (const Pixel &src) noexcept
| Copies another pixel colour over this one.
forcedinline void | setARGB (uint8 a_, uint8, uint8, uint8) noexcept
| Sets the pixel's colour from individual components.
template<class Pixel >
forcedinline void | blend (const Pixel &src) noexcept
| Blends another pixel onto this one.
template<class Pixel >
forcedinline void | blend (const Pixel &src, uint32 extraAlpha) noexcept
| Blends another pixel onto this one, applying an extra multiplier to its opacity.
template<class Pixel >
forcedinline void | tween (const Pixel &src, uint32 amount) noexcept
| Blends another pixel with this one, creating a colour that is somewhere between the two, as specified by the amount.
forcedinline void | setAlpha (uint8 newAlpha) noexcept
| Replaces the colour's alpha value with another one.
forcedinline void | multiplyAlpha (int multiplier) noexcept
| Multiplies the colour's alpha value with another one.
forcedinline void | multiplyAlpha (float multiplier) noexcept
forcedinline void | premultiply () noexcept
| Premultiplies the pixel's RGB values by its alpha.
forcedinline void | unpremultiply () noexcept
| Unpremultiplies the pixel's RGB values.
forcedinline void | desaturate () noexcept

## Detailed Description

Represents an 8-bit single-channel pixel, and can perform compositing operations on it.

This is used internally by the imaging classes.

See also
  PixelARGB, PixelRGB

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

The indexes of the different components in the byte layout of this type of colour.

Enumerator
indexA |

## Constructor & Destructor Documentation

## ◆ PixelAlpha()

PixelAlpha::PixelAlpha | ( |  | ) |
| default noexcept

Creates a pixel without defining its colour.

## Member Function Documentation

## ◆ getNativeARGB()

forcedinline uint32 PixelAlpha::getNativeARGB | ( |  | ) | const
| noexcept

Returns a uint32 which represents the pixel in a platform dependent format which is compatible with the native format of a PixelARGB.

See also
  PixelARGB::getNativeARGB

## ◆ getInARGBMaskOrder()

forcedinline uint32 PixelAlpha::getInARGBMaskOrder | ( |  | ) | const
| noexcept

Returns a uint32 which will be in argb order as if constructed with the following mask operation ((alpha << 24) | (red << 16) | (green << 8) | blue).

## ◆ getInARGBMemoryOrder()

uint32 PixelAlpha::getInARGBMemoryOrder | ( |  | ) | const
| noexcept

Returns a uint32 which when written to memory, will be in the order a, r, g, b.

In other words, if the return-value is read as a uint8 array then the elements will be in the order of a, r, g, b

## ◆ getEvenBytes()

forcedinline uint32 PixelAlpha::getEvenBytes | ( |  | ) | const
| noexcept

Return channels with an even index and insert zero bytes between them.

This is useful for blending operations. The exact channels which are returned is platform dependent but compatible with the return value of getEvenBytes of the PixelARGB class.

See also
  PixelARGB::getEvenBytes

## ◆ getOddBytes()

forcedinline uint32 PixelAlpha::getOddBytes | ( |  | ) | const
| noexcept

Return channels with an odd index and insert zero bytes between them.

This is useful for blending operations. The exact channels which are returned is platform dependent but compatible with the return value of getOddBytes of the PixelARGB class.

See also
  PixelARGB::getOddBytes

## ◆ getAlpha()

forcedinline uint8 PixelAlpha::getAlpha | ( |  | ) | const
| noexcept

## ◆ getRed()

forcedinline uint8 PixelAlpha::getRed | ( |  | ) | const
| noexcept

## ◆ getGreen()

forcedinline uint8 PixelAlpha::getGreen | ( |  | ) | const
| noexcept

## ◆ getBlue()

forcedinline uint8 PixelAlpha::getBlue | ( |  | ) | const
| noexcept

## ◆ set()

template<class Pixel >

forcedinline void PixelAlpha::set | ( | const Pixel & | src | ) |
| noexcept

Copies another pixel colour over this one.

This doesn't blend it - this colour is simply replaced by the other one.

## ◆ setARGB()

forcedinline void PixelAlpha::setARGB | ( | uint8 | a_,
|  | uint8 | ,
|  | uint8 | ,
|  | uint8 | )
| noexcept

Sets the pixel's colour from individual components.

## ◆ blend() [1/2]

template<class Pixel >

forcedinline void PixelAlpha::blend | ( | const Pixel & | src | ) |
| noexcept

Blends another pixel onto this one.

This takes into account the opacity of the pixel being overlaid, and blends it accordingly.

## ◆ blend() [2/2]

template<class Pixel >

forcedinline void PixelAlpha::blend | ( | const Pixel & | src,
|  | uint32 | extraAlpha )
| noexcept

Blends another pixel onto this one, applying an extra multiplier to its opacity.

The opacity of the pixel being overlaid is scaled by the extraAlpha factor before being used, so this can blend semi-transparently from a PixelRGB argument.

## ◆ tween()

template<class Pixel >

forcedinline void PixelAlpha::tween | ( | const Pixel & | src,
|  | uint32 | amount )
| noexcept

Blends another pixel with this one, creating a colour that is somewhere between the two, as specified by the amount.

## ◆ setAlpha()

forcedinline void PixelAlpha::setAlpha | ( | uint8 | newAlpha | ) |
| noexcept

Replaces the colour's alpha value with another one.

## ◆ multiplyAlpha() [1/2]

forcedinline void PixelAlpha::multiplyAlpha | ( | int | multiplier | ) |
| noexcept

Multiplies the colour's alpha value with another one.

## ◆ multiplyAlpha() [2/2]

forcedinline void PixelAlpha::multiplyAlpha | ( | float | multiplier | ) |
| noexcept

## ◆ premultiply()

forcedinline void PixelAlpha::premultiply | ( |  | ) |
| noexcept

Premultiplies the pixel's RGB values by its alpha.

## ◆ unpremultiply()

forcedinline void PixelAlpha::unpremultiply | ( |  | ) |
| noexcept

Unpremultiplies the pixel's RGB values.

## ◆ desaturate()

forcedinline void PixelAlpha::desaturate | ( |  | ) |
| noexcept

The documentation for this class was generated from the following file:

- juce_PixelFormats.h